diff --git a/storage/innobase/trx/trx0trx.cc b/storage/innobase/trx/trx0trx.cc
index 4af1f5d..b2ce5af 100644
--- a/storage/innobase/trx/trx0trx.cc
+++ b/storage/innobase/trx/trx0trx.cc
@@ -110,7 +110,11 @@ committed.
                             list of things we need to clean up during
                             trx_erase_lists.
 */
+#ifdef HAVE_LOCK_FREE_READVIEW
+static void trx_release_impl_and_expl_locks(trx_t *trx, bool atShutdown = false);
+#else
 static void trx_release_impl_and_expl_locks(trx_t *trx, bool serialized);
+#endif
 
 /** Set flush observer for the transaction
 @param[in,out]	trx		transaction struct
@@ -205,7 +209,11 @@ static void trx_init(trx_t *trx) {
 
   trx->last_sql_stat_start.least_undo_no = 0;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(!trx->read_view.is_open());
+#else
   ut_ad(!MVCC::is_view_active(trx->read_view));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   trx->lock.rec_cached = 0;
 
@@ -252,6 +260,13 @@ struct TrxFactory {
 
     new (&trx->lock.table_locks) lock_pool_t();
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    new (&trx->read_view) ReadView();
+
+    trx->rw_trx_hash_element = nullptr;
+    trx->rw_trx_hash_pins = nullptr;
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
     trx_init(trx);
 
     trx->state = TRX_STATE_NOT_STARTED;
@@ -279,8 +294,10 @@ struct TrxFactory {
   @param trx the transaction for which to release resources */
   static void destroy(trx_t *trx) {
     ut_a(trx->magic_n == TRX_MAGIC_N);
+#ifndef HAVE_LOCK_FREE_READVIEW
     ut_ad(!trx->in_rw_trx_list);
     ut_ad(!trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     ut_a(trx->lock.wait_lock == NULL);
     ut_a(trx->lock.wait_thr == NULL);
@@ -305,7 +322,12 @@ struct TrxFactory {
 
     trx->mod_tables.~trx_mod_tables_t();
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+      ut_ad(!trx->read_view.is_open());
+    trx->read_view.~ReadView();
+#else
     ut_ad(trx->read_view == NULL);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     if (!trx->lock.rec_pool.empty()) {
       /* See lock_trx_alloc_locks() why we only free
@@ -345,8 +367,10 @@ struct TrxFactory {
 
     ut_ad(trx->mysql_thd == 0);
 
+#ifndef HAVE_LOCK_FREE_READVIEW
     ut_ad(!trx->in_rw_trx_list);
     ut_ad(!trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     ut_a(trx->lock.wait_thr == NULL);
     ut_a(trx->lock.wait_lock == NULL);
@@ -448,6 +472,11 @@ static trx_t *trx_create_low() {
   /* We just got trx from pool, it should be non locking */
   ut_ad(trx->will_lock == 0);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    ut_ad(trx->state == TRX_STATE_NOT_STARTED);
+  ut_ad(trx->rw_trx_hash_pins == nullptr);
+#endif /* HAVE_LOCK_FREE_READVIEW */
+
   trx->persists_gtid = false;
 
   trx->api_trx = false;
@@ -475,12 +504,77 @@ static trx_t *trx_create_low() {
   trx_free(). */
   ut_a(trx->mod_tables.size() == 0);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_sys->register_trx(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   return (trx);
 }
 
 /**
 Release a trx_t instance back to the pool.
 @param trx the instance to release. */
+#ifdef HAVE_LOCK_FREE_READVIEW
+void trx_free(trx_t *&trx) {
+  ut_ad(!trx->declared_to_be_inside_innodb);
+  ut_ad(trx->n_mysql_tables_in_use == 0);
+  ut_ad(trx->mysql_n_tables_locked == 0);
+  ut_ad(!trx->internal);
+
+  if (trx->declared_to_be_inside_innodb) {
+    ib::error(ER_IB_MSG_1270)
+        << "Freeing a trx (" << trx << ", " << trx_get_id_for_print(trx)
+        << ") which is declared"
+           " to be processing inside InnoDB";
+
+    trx_print(stderr, trx, 600);
+    putc('\n', stderr);
+
+    /* This is an error but not a fatal error. We must keep the coutners like
+    srv_conc.n_active accurate. */
+    srv_conc_force_exit_innodb(trx);
+  }
+
+  if (trx->n_mysql_tables_in_use > 0 || trx->mysql_n_tables_locked > 0) {
+    ib::error(ER_IB_MSG_1270)
+        << "MySQL is freeing a thd though"
+           " trx->n_mysql_tables_in_use is "
+        << trx->n_mysql_tables_in_use << " and trx->mysql_n_tables_locked is "
+        << trx->mysql_n_tables_locked << ".";
+
+    trx_print(stderr, trx, 600);
+    ut_print_buf(stderr, trx, sizeof(trx_t));
+    putc('\n', stderr);
+  }
+
+  trx->dict_operation = TRX_DICT_OP_NONE;
+  assert_trx_is_inactive(trx);
+
+  trx_sys->deregister_trx(trx);
+  assert_trx_is_free(trx);
+
+  trx_sys->rw_trx_hash.put_pins(trx);
+  trx->mysql_thd = nullptr;
+
+  // FIXME: We need to avoid this heap free/alloc for each commit.
+  if (trx->lock.autoinc_locks != nullptr) {
+    ut_ad(ib_vector_is_empty(trx->lock.autoinc_locks));
+    /* We allocated a dedicated heap for the vector. */
+    ib_vector_free(trx->lock.autoinc_locks);
+    trx->lock.autoinc_locks = nullptr;
+  }
+
+  trx->mod_tables.clear();
+
+  ut_ad(trx->is_dd_trx == false);
+
+  /* trx locking state should have been reset before returning trx
+  to pool */
+  ut_ad(trx->will_lock == 0);
+
+  trx_pools->mem_free(trx);
+  trx = nullptr;
+}
+#else
 static void trx_free(trx_t *&trx) {
   assert_trx_is_free(trx);
 
@@ -507,6 +601,7 @@ static void trx_free(trx_t *&trx) {
 
   trx = NULL;
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Creates a transaction object for background operations by the master thread.
  @return own: transaction object */
@@ -527,12 +622,14 @@ trx_t *trx_allocate_for_mysql(void) {
 
   trx = trx_allocate_for_background();
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   trx_sys_mutex_enter();
 
   ut_d(trx->in_mysql_trx_list = TRUE);
   UT_LIST_ADD_FIRST(trx_sys->mysql_trx_list, trx);
 
   trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   return (trx);
 }
@@ -570,6 +667,7 @@ static void trx_validate_state_before_free(trx_t *trx) {
   assert_trx_is_inactive(trx);
 }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
 /** Free and initialize a transaction object instantiated during recovery.
 @param[in,out]	trx	transaction object to free and initialize */
 void trx_free_resurrected(trx_t *trx) {
@@ -579,6 +677,7 @@ void trx_free_resurrected(trx_t *trx) {
 
   trx_free(trx);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Free a transaction that was allocated by background or user threads.
 @param[in,out]	trx	transaction object to free */
@@ -588,6 +687,32 @@ void trx_free_for_background(trx_t *trx) {
   trx_free(trx);
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** At shutdown, frees a transaction object. */
+void trx_free_at_shutdown(trx_t *trx) {
+  ut_ad(trx->is_recovered);
+  ut_a(trx_state_eq(trx, TRX_STATE_PREPARED) ||
+       trx_state_eq(trx, TRX_STATE_ACTIVE));
+  ut_a(trx->magic_n == TRX_MAGIC_N);
+
+  trx_release_impl_and_expl_locks(trx, true);
+  trx_undo_free_at_shutdown(trx);
+
+  ut_a(!trx->read_only);
+
+  DBUG_LOG("trx", "Free prepared: " << trx);
+  trx->state = TRX_STATE_NOT_STARTED;
+
+  /* Undo trx_resurrect_table_locks(). */
+  lock_trx_lock_list_init(&trx->lock.trx_locks);
+
+  /* Note: This vector is not guaranteed to be empty because the transaction
+  was never committed and therefore lock_trx_release() was not called. */
+  trx->lock.table_locks.clear();
+
+  trx_free(trx);
+}
+#else
 /** At shutdown, frees a transaction object that is in the PREPARED state. */
 void trx_free_prepared(trx_t *trx) /*!< in, own: trx object */
 {
@@ -609,6 +734,7 @@ void trx_free_prepared(trx_t *trx) /*!< in, own: trx object */
 
   trx_free(trx);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Disconnect a transaction from MySQL and optionally mark it as if
 it's been recovered. For the marking the transaction must be in prepared state.
@@ -619,6 +745,18 @@ finally freed.
 @param[in]	prepared	boolean value to specify whether trx is
                                 for recovery or not. */
 inline void trx_disconnect_from_mysql(trx_t *trx, bool prepared) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx->read_view.close();
+
+  if (prepared) {
+    ut_ad(trx_state_eq(trx, TRX_STATE_PREPARED));
+
+    trx->is_recovered = true;
+    trx->mysql_thd = nullptr;
+    /* todo/fixme: suggest to do it at innodb prepare */
+    trx->will_lock = 0;
+  }
+#else
   trx_sys_mutex_enter();
 
   ut_ad(trx->in_mysql_trx_list);
@@ -642,6 +780,7 @@ inline void trx_disconnect_from_mysql(trx_t *trx, bool prepared) {
   }
 
   trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 /** Disconnect a transaction from MySQL.
@@ -793,7 +932,9 @@ static trx_t *trx_resurrect_insert(
 
       if (srv_force_recovery == 0) {
         trx->state = TRX_STATE_PREPARED;
+#ifndef HAVE_LOCK_FREE_READVIEW
         ++trx_sys->n_prepared_trx;
+#endif /* HAVE_LOCK_FREE_READVIEW */
       } else {
         ib::info(ER_IB_MSG_1205) << "Since innodb_force_recovery"
                                     " > 0, we will force a rollback.";
@@ -857,7 +998,9 @@ static void trx_resurrect_update_in_prepared_state(
     ut_ad(trx->state != TRX_STATE_FORCED_ROLLBACK);
 
     if (trx_state_eq(trx, TRX_STATE_NOT_STARTED)) {
+#ifndef HAVE_LOCK_FREE_READVIEW
       ++trx_sys->n_prepared_trx;
+#endif /* HAVE_LOCK_FREE_READVIEW */
     } else {
       ut_ad(trx_state_eq(trx, TRX_STATE_PREPARED));
     }
@@ -950,7 +1093,17 @@ static void trx_resurrect(trx_rseg_t *rseg) {
        undo = UT_LIST_GET_NEXT(undo_list, undo)) {
     trx = trx_resurrect_insert(undo, rseg);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+      trx_sys->rw_trx_hash.insert(trx);
+    trx_sys->rw_trx_hash.put_pins(trx);
+#ifdef UNIV_DEBUG
+    if (trx->id > trx_sys->rw_max_trx_no) {
+      trx_sys->rw_max_trx_no = trx->id;
+    }
+#endif /* UNIV_DEBUG */
+#else
     trx_sys_rw_trx_add(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     trx_resurrect_table_ids(trx, &trx->rsegs.m_redo, undo);
   }
@@ -958,6 +1111,30 @@ static void trx_resurrect(trx_rseg_t *rseg) {
   /* Ressurrect transactions that were doing updates. */
   for (undo = UT_LIST_GET_FIRST(rseg->update_undo_list); undo != NULL;
        undo = UT_LIST_GET_NEXT(undo_list, undo)) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+      /* Check the trx_sys->rw_trx_hash first. */
+    trx_t *trx = trx_sys->find(nullptr, undo->trx_id, false);
+
+    if (trx == nullptr) {
+      trx = trx_allocate_for_background();
+
+      ut_d(trx->start_file = __FILE__);
+      ut_d(trx->start_line = __LINE__);
+
+      trx_resurrect_update(trx, undo, rseg);
+
+      trx_sys->rw_trx_hash.insert(trx);
+      trx_sys->rw_trx_hash.put_pins(trx);
+    } else {
+      trx_resurrect_update(trx, undo, rseg);
+    }
+
+#ifdef UNIV_DEBUG
+    if (trx->id > trx_sys->rw_max_trx_no) {
+      trx_sys->rw_max_trx_no = trx->id;
+    }
+#endif /* UNIV_DEBUG */
+#else
     /* Check the trx_sys->rw_trx_set first. */
     trx_sys_mutex_enter();
 
@@ -975,6 +1152,7 @@ static void trx_resurrect(trx_rseg_t *rseg) {
     trx_resurrect_update(trx, undo, rseg);
 
     trx_sys_rw_trx_add(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     trx_resurrect_table_ids(trx, &trx->rsegs.m_redo, undo);
   }
@@ -1006,6 +1184,7 @@ void trx_lists_init_at_db_start(void) {
   }
   undo::spaces->s_unlock();
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   TrxIdSet::iterator end = trx_sys->rw_trx_set.end();
 
   for (TrxIdSet::iterator it = trx_sys->rw_trx_set.begin(); it != end; ++it) {
@@ -1018,6 +1197,7 @@ void trx_lists_init_at_db_start(void) {
 
     UT_LIST_ADD_FIRST(trx_sys->rw_trx_list, it->m_trx);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 }
 
 /** Get next redo rollback segment in round-robin fashion.
@@ -1185,6 +1365,9 @@ void trx_assign_rseg_temp(trx_t *trx) {
       srv_read_only_mode ? nullptr : get_next_temp_rseg();
 
   if (trx->id == 0) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_sys->register_rw(trx);
+#else
     mutex_enter(&trx_sys->mutex);
 
     trx->id = trx_sys_get_new_trx_id();
@@ -1194,6 +1377,7 @@ void trx_assign_rseg_temp(trx_t *trx) {
     trx_sys->rw_trx_set.insert(TrxTrack(trx->id, trx));
 
     mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 }
 
@@ -1256,6 +1440,16 @@ static void trx_start_low(
   ut_a(ib_vector_is_empty(trx->lock.autoinc_locks));
   ut_a(trx->lock.table_locks.empty());
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    /* No other thread can access this trx object through rw_trx_hash, thus we
+  don't need trx_sys.mutex protection for that purposes. Still this trx can be
+  found through trx_sys->trx_list, which means state change must be protected by
+  e.g. trx->mutex.
+
+  For now we update it without mutex protection, because original code did it in
+  this way. It has to be reviewed and fixed properly. */
+  trx->state = TRX_STATE_ACTIVE;
+#else
   /* If this transaction came from trx_allocate_for_mysql(),
   trx->in_mysql_trx_list would hold. In that case, the trx->state
   change must be protected by the trx_sys->mutex, so that
@@ -1267,6 +1461,7 @@ static void trx_start_low(
   e.g., the transaction state can be set earlier but we are forced to
   set it under the protection of the trx_sys_t::mutex because some
   trx list assertions are triggered unnecessarily. */
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* By default all transactions are in the read-only list unless they
   are non-locking auto-commit read only transactions or background
@@ -1281,6 +1476,17 @@ static void trx_start_low(
     /* Temporary rseg is assigned only if the transaction
     updates a temporary table */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+      ut_ad(trx->rsegs.m_redo.rseg != nullptr || srv_read_only_mode ||
+          srv_force_recovery >= SRV_FORCE_NO_TRX_UNDO);
+
+    trx_sys->register_rw(trx);
+#ifdef UNIV_DEBUG
+    if (trx->id > trx_sys->rw_max_trx_no) {
+      trx_sys->rw_max_trx_no = trx->id;
+    }
+#endif /* UNIV_DEBUG */
+#else
     trx_sys_mutex_enter();
 
     trx->id = trx_sys_get_new_trx_id();
@@ -1301,6 +1507,7 @@ static void trx_start_low(
     ut_ad(trx_sys_validate_trx_list());
 
     trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   } else {
     trx->id = 0;
@@ -1311,6 +1518,10 @@ static void trx_start_low(
       to write to the temporary table. */
 
       if (read_write) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+          ut_ad(!srv_read_only_mode);
+        trx_sys->register_rw(trx);
+#else
         trx_sys_mutex_enter();
 
         ut_ad(!srv_read_only_mode);
@@ -1322,13 +1533,18 @@ static void trx_start_low(
         trx_sys->rw_trx_set.insert(TrxTrack(trx->id, trx));
 
         trx_sys_mutex_exit();
+#endif /* HAVE_LOCK_FREE_READVIEW */
       }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
       trx->state = TRX_STATE_ACTIVE;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     } else {
       ut_ad(!read_write);
+#ifndef HAVE_LOCK_FREE_READVIEW
       trx->state = TRX_STATE_ACTIVE;
+#endif /* HAVE_LOCK_FREE_READVIEW */
     }
   }
 
@@ -1346,6 +1562,194 @@ static void trx_start_low(
   MONITOR_INC(MONITOR_TRX_ACTIVE);
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** Set the transaction serialisation number.
+ @return true if the transaction number was added to the serialisation_list. */
+static void trx_serialise(
+    trx_t *trx,                         /*!< in/out: transaction */
+    mtr_t *mtr,                         /*!< in/out: mini-transaction */
+    trx_undo_ptr_t *redo_rseg_undo_ptr, /*!< in/out: Set trx
+                                        serialisation number in
+                                        referred undo rseg. */
+    trx_undo_ptr_t *temp_rseg_undo_ptr) /*!< in/out: Set trx
+                                        serialisation number in
+                                        referred undo rseg. */
+{
+  trx_rseg_t *redo_rseg = nullptr;
+  trx_rseg_t *temp_rseg = nullptr;
+  //trx_id_t new_id;
+
+  if (redo_rseg_undo_ptr != nullptr) {
+    ut_ad(mutex_own(&redo_rseg_undo_ptr->rseg->mutex));
+    redo_rseg = redo_rseg_undo_ptr->rseg;
+  }
+
+  if (temp_rseg_undo_ptr != nullptr) {
+    ut_ad(mutex_own(&temp_rseg_undo_ptr->rseg->mutex));
+    temp_rseg = temp_rseg_undo_ptr->rseg;
+  }
+
+  if ((redo_rseg != nullptr && redo_rseg->last_page_no == FIL_NULL) ||
+      (temp_rseg != nullptr && temp_rseg->last_page_no == FIL_NULL)) {
+    /* NOTE: here we MUST acquire the mutex to protect the purge queue before
+    invoking assign_new_trx_no, otherwise it might be possible to push a
+    segment with smaller trx_no than last time popped. */
+    mutex_enter(&purge_sys->pq_mutex);
+  }
+
+  trx_sys->assign_new_trx_no(trx);
+  //new_id = trx->no;
+
+  /* If the rollack segment is not empty then the
+  new trx_t::no can't be less than any trx_t::no
+  already in the rollback segment. User threads only
+  produce events when a rollback segment is empty. */
+  if ((redo_rseg != nullptr && redo_rseg->last_page_no == FIL_NULL) ||
+      (temp_rseg != nullptr && temp_rseg->last_page_no == FIL_NULL)) {
+    TrxUndoRsegs elem(trx->no);
+
+    if (redo_rseg != nullptr && redo_rseg->last_page_no == FIL_NULL) {
+      elem.push_back(redo_rseg);
+    }
+
+    if (temp_rseg != nullptr && temp_rseg->last_page_no == FIL_NULL) {
+      elem.push_back(temp_rseg);
+    }
+
+    purge_sys->purge_queue->push(elem);
+    mutex_exit(&purge_sys->pq_mutex);
+  }
+
+  /* new_id is a special trx id created for r/w trx which has update
+  undo. Such trx id is used by purge and the trx itself has no activity
+  so it's "effectived" committed right away. We need explicitly log it
+  in redo log, otherwise replica nodes would think this trx remains
+  active for ever. */
+  //mlog_log_transaction_end(mtr, new_id);
+}
+
+/** Assign the transaction its history serialisation number and write the
+ update UNDO log record to the assigned rollback segment.
+ @return true if a serialisation log was written */
+static void trx_write_serialisation_history(
+    trx_t *trx, /*!< in/out: transaction */
+    mtr_t *mtr) /*!< in/out: mini-transaction */
+{
+  /* Change the undo log segment states from TRX_UNDO_ACTIVE to some
+  other state: these modifications to the file data structure define
+  the transaction as committed in the file based domain, at the
+  serialization point of the log sequence number lsn obtained below. */
+
+  /* We have to hold the rseg mutex because update log headers have
+  to be put to the history list in the (serialisation) order of the
+  UNDO trx number. This is required for the purge in-memory data
+  structures too. */
+
+  bool own_redo_rseg_mutex = false;
+  bool own_temp_rseg_mutex = false;
+
+  /* Get rollback segment mutex. */
+  if (trx->rsegs.m_redo.rseg != nullptr && trx_is_redo_rseg_updated(trx)) {
+    mutex_enter(&trx->rsegs.m_redo.rseg->mutex);
+    own_redo_rseg_mutex = true;
+  }
+
+  mtr_t temp_mtr;
+
+  if (trx->rsegs.m_noredo.rseg != nullptr && trx_is_temp_rseg_updated(trx)) {
+    mutex_enter(&trx->rsegs.m_noredo.rseg->mutex);
+    own_temp_rseg_mutex = true;
+    mtr_start(&temp_mtr);
+    temp_mtr.set_log_mode(MTR_LOG_NO_REDO);
+  }
+
+  /* If transaction involves insert then truncate undo logs. */
+  if (trx->rsegs.m_redo.insert_undo != nullptr) {
+    trx_undo_set_state_at_finish(trx->rsegs.m_redo.insert_undo, mtr);
+  }
+
+  if (trx->rsegs.m_noredo.insert_undo != nullptr) {
+    trx_undo_set_state_at_finish(trx->rsegs.m_noredo.insert_undo, &temp_mtr);
+  }
+
+  /* If transaction involves update then add rollback segments
+  to purge queue. */
+  if (trx->rsegs.m_redo.update_undo != nullptr ||
+      trx->rsegs.m_noredo.update_undo != nullptr) {
+    /* Assign the transaction serialisation number and add these
+    rollback segments to purge trx-no sorted priority queue
+    if this is the first UNDO log being written to assigned
+    rollback segments. */
+
+    trx_undo_ptr_t *redo_rseg_undo_ptr =
+        trx->rsegs.m_redo.update_undo != nullptr ? &trx->rsegs.m_redo : nullptr;
+
+    trx_undo_ptr_t *temp_rseg_undo_ptr =
+        trx->rsegs.m_noredo.update_undo != nullptr ? &trx->rsegs.m_noredo
+                                                   : nullptr;
+
+    /* Will set trx->no and will add rseg to purge queue. */
+    trx_serialise(trx, mtr, redo_rseg_undo_ptr, temp_rseg_undo_ptr);
+
+    /* It is not necessary to obtain trx->undo_mutex here because
+    only a single OS thread is allowed to do the transaction commit
+    for this transaction. */
+    if (trx->rsegs.m_redo.update_undo != nullptr) {
+      page_t *undo_hdr_page;
+
+      undo_hdr_page =
+          trx_undo_set_state_at_finish(trx->rsegs.m_redo.update_undo, mtr);
+
+      /* Delay update of rseg_history_len if we plan to add
+      non-redo update_undo too. This is to avoid immediate
+      invocation of purge as we need to club these 2 segments
+      with same trx-no as single unit. */
+      bool update_rseg_len = !(trx->rsegs.m_noredo.update_undo != nullptr);
+
+      /* Set flag if GTID information need to persist. */
+      auto undo_ptr = &trx->rsegs.m_redo;
+      trx_undo_gtid_set(trx, undo_ptr->update_undo);
+
+      trx_undo_update_cleanup(trx, undo_ptr, undo_hdr_page, update_rseg_len,
+                              (update_rseg_len ? 1 : 0), mtr);
+    }
+
+    DBUG_EXECUTE_IF("ib_trx_crash_during_commit", DBUG_SUICIDE(););
+
+    if (trx->rsegs.m_noredo.update_undo != nullptr) {
+      page_t *undo_hdr_page;
+
+      undo_hdr_page = trx_undo_set_state_at_finish(
+          trx->rsegs.m_noredo.update_undo, &temp_mtr);
+
+      ulint n_added_logs = (redo_rseg_undo_ptr != nullptr) ? 2 : 1;
+
+      trx_undo_update_cleanup(trx, &trx->rsegs.m_noredo, undo_hdr_page, true,
+                              n_added_logs, &temp_mtr);
+    }
+  }
+
+  if (own_redo_rseg_mutex) {
+    mutex_exit(&trx->rsegs.m_redo.rseg->mutex);
+    own_redo_rseg_mutex = false;
+  }
+
+  if (own_temp_rseg_mutex) {
+    mutex_exit(&trx->rsegs.m_noredo.rseg->mutex);
+    own_temp_rseg_mutex = false;
+    mtr_commit(&temp_mtr);
+  }
+
+  MONITOR_INC(MONITOR_TRX_COMMIT_UNDO);
+
+  /* Update the latest MySQL binlog name and offset information
+  in trx sys header only if MySQL binary logging is on and clone
+  is has ensured commit order at final stage. */
+  if (Clone_handler::need_commit_order()) {  // NOLINT
+    trx_sys_update_mysql_binlog_offset(trx, mtr);
+  }
+}
+#else
 /** Set the transaction serialisation number.
  @return true if the transaction number was added to the serialisation_list. */
 static bool trx_serialisation_number_get(
@@ -1546,6 +1950,7 @@ static bool trx_write_serialisation_history(
 
   return (serialised);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /********************************************************************
 Finalize a transaction containing updates for a FTS table. */
@@ -1687,10 +2092,239 @@ static void trx_update_mod_tables_timestamp(trx_t *trx) /*!< in: transaction */
   trx->mod_tables.clear();
 }
 
-/**
-Erase the transaction from running transaction lists and serialization
-list. Active RW transaction list of a MVCC snapshot(ReadView::prepare)
-won't include this transaction after this call. All implicit locks are
+#ifdef HAVE_LOCK_FREE_READVIEW
+static void trx_release_impl_and_expl_locks(trx_t *trx, bool atShutdown) {
+  check_trx_state(trx);
+  ut_ad(trx_state_eq(trx, TRX_STATE_ACTIVE) ||
+        trx_state_eq(trx, TRX_STATE_PREPARED));
+
+  /* Check and get GTID to be persisted. Do it outside trx_sys mutex. */
+  Gtid_desc gtid_desc;
+  auto &gtid_persistor = clone_sys->get_gtid_persistor();
+  gtid_persistor.get_gtid_info(trx, gtid_desc);
+
+  if (trx->id > 0) {
+    /* For consistent snapshot, we need to remove current
+    transaction from running transaction id list for mvcc
+    before doing commit and releasing locks. */
+    if (!atShutdown) {
+      trx_sys->deregister_rw(trx);
+    }
+
+    /* Add GTID to be persisted to disk table. It must be done ...
+    1.After the transaction is marked committed in undo. Otherwise
+      GTID might get committed before the transaction commit on disk.
+    2.Before it is removed from serialization list. Otherwise the transaction
+      undo could get purged before persisting GTID on disk table. */
+    if (gtid_desc.m_is_set) {
+      auto &gtid_persistor = clone_sys->get_gtid_persistor();
+      gtid_persistor.add(gtid_desc);
+    }
+  }
+
+  trx_mutex_enter(trx);
+  /* Please consider this particular point in time as the moment the trx's
+  implicit locks become released.
+  This change is protected by both trx_sys->mutex and trx->mutex.
+  Therefore, there are two secure ways to check if the trx still can hold
+  implicit locks:
+  (1) if you only know id of the trx, then you can obtain trx_sys->mutex and
+      check if trx is still in rw_trx_set. This works, because the call to
+      trx_erase_list() which removes trx from this list several lines above is
+      also protected by trx_sys->mutex. We use this approach in
+      lock_rec_convert_impl_to_expl() by using trx_rw_is_active()
+  (2) if you have pointer to trx, and you know it is safe to access (say, you
+      hold reference to this trx which prevents it from being freed) then you
+      can obtain trx->mutex and check if trx->state is equal to
+      TRX_STATE_COMMITTED_IN_MEMORY. We use this approach in
+      lock_rec_convert_impl_to_expl_for_trx() when deciding for the final time
+      if we really want to create explicit lock on behalf of implicit lock
+      holder. */
+  trx->state = TRX_STATE_COMMITTED_IN_MEMORY;
+  trx_mutex_exit(trx);
+
+  lock_trx_release_locks(trx);
+}
+
+/** Commits a transaction in memory. */
+static void trx_commit_in_memory(
+    trx_t *trx,       /*!< in/out: transaction */
+    const mtr_t *mtr) /*!< in: mini-transaction of
+                      trx_write_serialisation_history(), or NULL if
+                      the transaction did not modify anything */
+{
+  trx->must_flush_log_later = false;
+  trx->ddl_must_flush = false;
+  trx->read_view.close();
+
+  if (trx_is_autocommit_non_locking(trx)) {
+    ut_ad(trx->id == 0);
+    ut_ad(trx->read_only);
+    ut_a(!trx->is_recovered);
+    ut_ad(trx->rsegs.m_redo.rseg == nullptr);
+
+    /* Note: We are asserting without holding the lock mutex. But
+    that is OK because this transaction is not waiting and cannot
+    be rolled back and no new locks can (or should not) be added
+    because it is flagged as a non-locking read-only transaction. */
+
+    ut_a(UT_LIST_GET_LEN(trx->lock.trx_locks) == 0);
+
+    /* This state change is not protected by any mutex, therefore
+    there is an inherent race here around state transition during
+    printouts. We ignore this race for the sake of efficiency.
+    However, the trx_sys_t::mutex will protect the trx_t instance
+    and it cannot be removed from the mysql_trx_list and freed
+    without first acquiring the trx_sys_t::mutex. */
+
+    ut_ad(trx_state_eq(trx, TRX_STATE_ACTIVE));
+
+    MONITOR_INC(MONITOR_TRX_NL_RO_COMMIT);
+
+    /* AC-NL-RO transactions can't be rolled back asynchronously. */
+    ut_ad(!trx->abort);
+    ut_ad(!(trx->in_innodb & (TRX_FORCE_ROLLBACK | TRX_FORCE_ROLLBACK_ASYNC)));
+
+    trx->state = TRX_STATE_NOT_STARTED;
+
+  } else {
+    trx_release_impl_and_expl_locks(trx);
+    DEBUG_SYNC_C("after_remove_serial_list_release_locks");
+
+    /* Remove the transaction from the list of active
+    transactions now that it no longer holds any user locks. */
+
+    ut_ad(trx_state_eq(trx, TRX_STATE_COMMITTED_IN_MEMORY));
+    DEBUG_SYNC_C("after_trx_committed_in_memory");
+
+    if (trx->read_only || trx->rsegs.m_redo.rseg == nullptr) {
+      MONITOR_INC(MONITOR_TRX_RO_COMMIT);
+    } else {
+      ut_ad(trx->id > 0);
+      MONITOR_INC(MONITOR_TRX_RW_COMMIT);
+    }
+  }
+
+  if (trx->rsegs.m_redo.rseg != nullptr) {
+    trx_rseg_t *rseg = trx->rsegs.m_redo.rseg;
+    ut_ad(rseg->trx_ref_count > 0);
+
+    /* Multiple transactions can simultaneously decrement
+    the atomic counter. */
+    rseg->trx_ref_count--;
+  }
+
+  /* Reset flag that SE persists GTID. */
+  auto &gtid_persistor = clone_sys->get_gtid_persistor();
+  gtid_persistor.set_persist_gtid(trx, false);
+
+  if (mtr != nullptr) {
+    if (trx->rsegs.m_redo.insert_undo != nullptr) {
+      trx_undo_insert_cleanup(&trx->rsegs.m_redo, false);
+    }
+
+    if (trx->rsegs.m_noredo.insert_undo != nullptr) {
+      trx_undo_insert_cleanup(&trx->rsegs.m_noredo, true);
+    }
+
+    /* NOTE that we could possibly make a group commit more
+    efficient here: call os_thread_yield here to allow also other
+    trxs to come to commit! */
+
+    /*-------------------------------------*/
+
+    /* Depending on the my.cnf options, we may now write the log
+    buffer to the log files, making the transaction durable if
+    the OS does not crash. We may also flush the log files to
+    disk, making the transaction durable also at an OS crash or a
+    power outage.
+
+    The idea in InnoDB's group commit is that a group of
+    transactions gather behind a trx doing a physical disk write
+    to log files, and when that physical write has been completed,
+    one of those transactions does a write which commits the whole
+    group. Note that this group commit will only bring benefit if
+    there are > 2 users in the database. Then at least 2 users can
+    gather behind one doing the physical log write to disk.
+
+    If we are calling trx_commit() under prepare_commit_mutex, we
+    will delay possible log write and flush to a separate function
+    trx_commit_complete_for_mysql(), which is only called when the
+    thread has released the mutex. This is to make the
+    group commit algorithm to work. Otherwise, the prepare_commit
+    mutex would serialize all commits and prevent a group of
+    transactions from gathering. */
+
+    lsn_t lsn = mtr->commit_lsn();
+
+    if (lsn == 0) {
+      /* Nothing to be done. */
+    } else if (trx->flush_log_later) {
+      /* Do nothing yet */
+      trx->must_flush_log_later = true;
+
+      /* Remember current ddl_operation, because trx_init()
+      later will set ddl_operation to false. And the final
+      flush is even later. */
+      trx->ddl_must_flush = trx->ddl_operation;
+    } else if ((srv_flush_log_at_trx_commit == 0 ||
+                thd_requested_durability(trx->mysql_thd) ==
+                    HA_IGNORE_DURABILITY) &&
+               (!trx->ddl_operation)) {
+      /* Do nothing */
+    } else {
+      trx_flush_log_if_needed(lsn, trx);
+    }
+
+    trx->commit_lsn = lsn;
+
+    /* Tell server some activity has happened, since the trx
+    does changes something. Background utility threads like
+    master thread, purge thread or page_cleaner thread might
+    have some work to do. */
+    srv_active_wake_master_thread();
+  }
+
+  /* Free all savepoints, starting from the first. */
+  trx_named_savept_t *savep = UT_LIST_GET_FIRST(trx->trx_savepoints);
+
+  trx_roll_savepoints_free(trx, savep);
+
+  if (trx->fts_trx != nullptr) {
+    trx_finalize_for_fts(trx, trx->undo_no != 0);
+  }
+
+  trx_mutex_enter(trx);
+  trx->dict_operation = TRX_DICT_OP_NONE;
+
+  /* Because we can rollback transactions asynchronously, we change
+  the state at the last step. trx_t::abort cannot change once commit
+  or rollback has started because we will have released the locks by
+  the time we get here. */
+
+  if (trx->abort) {
+    trx->abort = false;
+    trx->state = TRX_STATE_FORCED_ROLLBACK;
+  } else {
+    trx->state = TRX_STATE_NOT_STARTED;
+  }
+
+  /* trx->in_mysql_trx_list would hold between
+  trx_allocate_for_mysql() and trx_free_for_mysql(). It does not
+  hold for recovered transactions or system transactions. */
+  assert_trx_is_free(trx);
+
+  trx_init(trx);
+
+  trx_mutex_exit(trx);
+
+  ut_a(trx->error_state == DB_SUCCESS);
+}
+#else
+/**
+Erase the transaction from running transaction lists and serialization
+list. Active RW transaction list of a MVCC snapshot(ReadView::prepare)
+won't include this transaction after this call. All implicit locks are
 also released by this call as trx is removed from rw_trx_list.
 @param[in]	trx		Transaction to erase, must have an ID > 0
 @param[in]	serialised	true if serialisation log was written
